// file: CGamma.h
// Created: 7/20/2005
// Creator: Matt Wheeler
// Last Modified: 
//        8/25/2006 Added specialized dose scaling code

/*
  Class which is the basis for the optimizatoin and statisitical
  reporting defines what a "binomial likelihood likelihood" should be: 
    
*/ 
////////////////////////////
//GSL Libraries Used
#include <gsl/gsl_vector.h>
#include <gsl/gsl_multimin.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_errno.h>
////////////////////////////

#include "CBinomial.h"

#ifndef __CLASS_CGAMMA
#define __CLASS_CGAMMA

const int GAMMA_ALPHA  = 0; 
const int GAMMA_BETA  = 1; 
const int GAMMA_GAMMA = 2; 

class CGamma: public CBinomial{
//////////////////////////////////////////////////////////////////////////////
//Define the friend function that is used in all the classes 
//but must be redefined in each class
//////////////////////////////////////////////////////////////////////////////
    
   
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

public: 
    CGamma::CGamma(); 
    CGamma::~CGamma();    
    
    void max_likelihod(int iter,double gtol,double relConv);
    virtual void print_output(); 
    void initializeParameters();
protected: 
    // need to change the link function of the to deal with our current situation
    // gamma
    virtual double link_function(const double *vector,double dose);

    
};

#endif
