// file: CMultistage.h
// Created: 7/20/2005
// Creator: Matt Wheeler
// Last Modified: 
//  8/25/2006 Added Code to rescale the doses for numerical stability  
 
/*
  Class which is the basis for the optimizatoin and statisitical
  reporting defines what a "binomial likelihood likelihood" should be: 
    
*/ 
////////////////////////////
//GSL Libraries Used
#include <gsl/gsl_vector.h>
#include <gsl/gsl_multimin.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_errno.h>
////////////////////////////

#include "CBinomial.h"


#ifndef __CLASS_CMULTISTAGE
#define __CLASS_CMULTISTAGE

const int MULTISTAGE_GAMMA = 0; 



class CMultiStage: public CBinomial{
//////////////////////////////////////////////////////////////////////////////
//Define the friend function that is used in all the classes 
//but must be redefined in each class
//////////////////////////////////////////////////////////////////////////////
    
   
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

public: // Profiling is the only public function that we need to worry about
        // other than the constructors and destructors. 
    CMultiStage::CMultiStage(); 
    CMultiStage::~CMultiStage();   
    
    void virtual initializeParameters();
    void  setDegreePoly(int deg);
    virtual CBinomial &  operator = (CBinomial &b); 
    virtual void print_output();  
    virtual  void  max_likelihod(int iter,double gtol,double relConv);
protected: 
    // need to change the link function of the to deal with our current situation
    // Quantal Linear link
    virtual double link_function(const double *vector,double dose);
    int polyDegree; 

    
};

#endif
