// file: CWeibullDR.h
// Created: 7/20/2005
// Creator: Matt Wheeler
// Last Modified: 10/28/2005
/*
  Class which is the basis for the optimizatoin and statisitical
  reporting defines what a "binomial likelihood likelihood" should be: 
    
*/ 
////////////////////////////
//GSL Libraries Used
#include <gsl/gsl_vector.h>
#include <gsl/gsl_multimin.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_errno.h>
////////////////////////////

#include "CBinomial.h"

#ifndef __CLASS_CWEIBULLDR
#define __CLASS_CWEIBULLDR

const int WIEBULLDR_GAMMA = 0; 
const int WIEBULLDR_BETA  = 1; 
const int WIEBULLDR_ALPHA = 2; 

class CWeibullDR: public CBinomial{
//////////////////////////////////////////////////////////////////////////////
//Define the friend function that is used in all the classes 
//but must be redefined in each class
//////////////////////////////////////////////////////////////////////////////
    
   
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

public: // Profiling is the only public function that we need to worry about
        // other than the constructors and destructors. 
    CWeibullDR::CWeibullDR(); 
    CWeibullDR::~CWeibullDR();    
    
    void initializeParameters();
    virtual void print_output(); 
protected: 
    // need to change the link function of the to deal with our current situation
    // Quantal Linear link
    virtual double link_function(const double *vector,double dose);
    void max_likelihod(int iter,double gtol,double relConv);

    
};

#endif
